/****************************************************************************/
/* MP3TAG2.CPP: Version 2.21, created  5.8.1999, by Leo Eibler (eibler_leo@ */
/* MP3TAG2.CPP: Reads MP3 Tags and puts it into a list-file          gmx.at)*/
/****************************************************************************/
/* Version History:                                                         */
/*   2. 4.1999     V1.00 (creating)                                         */
/*   5. 8.1999     V2.00 (creating)                                         */
/*   9. 8.1999     Last Update                                              */
/*--------------------------------------------------------------------------*/
/*   2. 4.1999     Open one MP3 File and display its MP3 Tag, but there are */
/*                 some errors.                                             */
/*   4. 4.1999     V1.02: fixed errors.                                     */
/*                 V1.04: can put the MP3 Tag info in a file                */
/*                 V1.05: some errors with MP3 files which have a 0 char-fix*/
/*                 V1.06: parses commandline                                */
/*                 V1.08: recursive function implemanted (Thanks to         */
/*                   Karl Weller for his KWTREE directory listing program)  */
/*                 V1.09: fixed some problems with the start-directory of   */
/*                   listing (-recursive option)                            */
/*   5. 4.1999     V1.10: fixed problems with opening the outputfile in the */
/*                   correct directory. Adds all memory and number of files.*/
/*                   Only displays directories with MP3 Files inside.       */
/*   5. 8.1999     V2.00: kicked KWTREE-routine !! now using my own with    */
/*                   recursive listing without store results in memory.     */
/*                   checks for ID3-TAG, reads it out.                      */
/*                   creates TEXT or HTML files with given arguments.       */
/*   6. 8.1999     V2.02: checks for valid MPEG Layer III Header and reads  */
/*                   information: mode, bitrates, sampling frequency,       */
/*                   version, .... calculates length of the song            */
/*   7. 8.1999     V2.03: can create links to file (if output to html)      */
/*                 V2.05: long file name support for files                  */
/*                 V2.10: some bugs killed, with the -nolf option, the      */
/*                   long file name routine is completly deactivated        */
/*   8. 8.1999     V2.11: lists only directories if they contains files     */
/*                   which matches with the given pattern                   */
/*   9. 8.1999     V2.12: counts number of files and playtime for all files */
/*                 V2.13: some error handling for changing drive and false  */
/*                   arguments                                              */
/*                 V2.15: deactivates interrupt 0x24 (error handler)        */
/*                 V2.20: -all argument, searches all drives for given      */
/*                   pattern                                                */
/*                 V2.21: -m3u argument, creates Winamp Playlist File       */
/****************************************************************************/


/****************************************************************************/
/* Note:                                                                    */
/*  I know, this is looks not very pretty. But I haven't got enough time,   */
/*  and my primary target was, that the program works.                      */
/*  I have a lot of MP3 files, but no description - and I won't not spent   */
/*  so much time in listing the files. So I write a little program.         */
/*  Sure, there are enough ways to optimize this program, but why should I  */
/*  do that ? - It does what I want.                                        */
/*  If you rewrite it, please send me an E-Mail and tell me where I can get */
/*  "your" version:                                                         */
/*                                                                          */
/*  E-Mail:                     eibler_leo@gmx.at                           */
/*                              eibler_leo@hotmail.com                      */
/*--------------------------------------------------------------------------*/
/*!                                                                        !*/
/*! Thank you Peter D. Kovacs !! Your TAG_PM.HTML module was very usefull  !*/
/*! for me (especially the MPEG Layer III info and the genre information)  !*/
/*!                                                                        !*/
/*--------------------------------------------------------------------------*/
/*  There are a lot of deactivated printf's and other routines ! I will     */
/*  cut them out later :-)                                                  */
/*--------------------------------------------------------------------------*/
/*  And:                                                                    */
/*    DON'T FORGET TO VISIT MY HOMEPAGE                                     */
/*                                                                          */
/*  Homepage:    http://www.geocities.com/SiliconValley/Bridge/3495         */
/*                                                                          */
/****************************************************************************/


/****************************************************************************/
/*  Compiled with BORLAND C/C++ V3.1                                        */
/*--------------------------------------------------------------------------*/
/*  Compiler/CodeGeneration: memory model: Huge                             */
/*                           Assume SS equals DS: Default for memory model  */
/*  Compiler/Advanced C Gen: Instruction Set: 80386                         */
/*                           Options: Generate Underbars                    */
/*  all others is default                                                   */
/****************************************************************************/

#define MP3TAG2_CPP_VERSION   2
#define MP3TAG2_CPP_REVISION  21


#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <dos.h>
#include <string.h>
#include <dir.h>
#include <io.h>
#include <direct.h>

#include "mp3tag2.h"
#include "longfile.c"

struct MP3 mp3;

struct LAYER3 layer3;

FILE *Out_Fptr;

/* If 1 -> display it */
char htm=1,  // create html file (1)  -  create text file     (0)
     rec=1,  // recursive        (1)  -  only in given dir    (0)
     gen=0,  // show genres      (1)  -  don't show genres    (0)
     alb=0,  // show album       (1)  -  don't show album     (0)
     tit=1,  // show title       (1)  -  don't show title     (0)
     inr=1,  // show interpret   (1)  -  don't show interpret (0)
     com=0,  // show comments    (1)  -  don't show comments  (0)
     yea=0,  // show year        (1)  -  don't show year      (0)
     fil=1,  // show filename    (1)  -  don't show filename  (0)
     m3u=0;  // creates Winamp Playlist (1), if activated htm and text deact.
char len=1;  // show length of song in minutes:seconds (1)
char cl=1,   // create link to file (if htm==1)
     lf=1,   // long filenames
     all=0;  // scan all drives

char std_out=1;  // output to screen (1)  -  output to file   (0)


char outfile[MAXPATH];  // output filename if std_out==0

int rt=0;  // return value for recursive function read_dir

#define bitrate()      (my_bitrates[layer3.version]\
                                   [layer3.layer-1]\
                                   [layer3.bitrate_index])
#define sfreq()        (my_s_freq[layer3.version][layer3.sampling_frequency])
#define mode_name()    (my_mode_names[layer3.mode])
#define layer_name()   (my_layer_names[layer3.layer-1])
#define version_name() (my_version_names[layer3.version]);
#define version_num()  (my_version_nums[layer3.version]);


#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

void interrupt ( *old24h_handler)(__CPPARGS);

void interrupt new24h_handler(__CPPARGS)
{
     // nothing to do
}


// Function d
//   input: t[30]  - title, interpret, comment, album of mp3 tag
//   returns: ASCII Z string
char *d(char t[30])
{
     int i;
     char t2[31];

     for(i=0; i<30; i++)
       t2[i]=t[i];
     t2[i]=0;
     return t2;
}

// Procedure kill_too_many_spaces
//   input: buf  - buffer with max. length of 30 characters
//   output: buf  - buffer with only one space between 2 other characters
//   returns: none
void kill_too_many_spaces(char *buf)
{
     int i, rcount=0;
     char buf2[30+2];

     strcpy(buf2, buf);
     for(i=0; i<30; i++)
     {
       buf[rcount]=buf2[i];
       rcount++;
       if(buf2[i]==' ')
       {
         i++;
         if(buf2[i]==' ')
         {
           while(buf2[i]==' ')
             i++;
           i--;
           continue;
         }
         else
           i--;
       }
     }
     buf[rcount-1]=0;
}

// Procedure out_text
//   input: file  - filename
//   output: none
//   returns: none
//   displays or writes filename, title, interpret, comment, album, year and
//   genre on screen or to an file
void out_text(char *file)
{
     if(std_out)
     {
       kill_too_many_spaces(mp3.title);
       kill_too_many_spaces(mp3.interpret);
       kill_too_many_spaces(mp3.album);
       kill_too_many_spaces(mp3.comment);
       if(fil)
         if(lf)
           printf("%14s - ", longfile.name);
         else
           printf("%14s - ", file);
       if(tit)
         printf("%s - ", mp3.title);
       if(inr)
         printf("%s - ", mp3.interpret);
       if(com)
         printf("%s - ", mp3.comment);
       if(alb)
         printf("%s - ", mp3.album);
       if(yea)
         printf("%s - ", mp3.year);
       if(gen)
         printf("%s - ", genres[mp3.genre]);
       if(len)
         printf("%u:%02d - ", length/60, length%60);
       printf("\b\b \n");
     }
     else
     {
       if(fil)
         if(lf)
           fprintf(Out_Fptr, "%14s  ", longfile.name);
         else
           fprintf(Out_Fptr, "%14s  ", file);
       if(tit)
         fprintf(Out_Fptr, "%s  ", mp3.title);
       if(inr)
         fprintf(Out_Fptr, "%s  ", mp3.interpret);
       if(com)
         fprintf(Out_Fptr, "[%s]  ", mp3.comment);
       if(alb)
         fprintf(Out_Fptr, "%s  ", mp3.album);
       if(yea)
         fprintf(Out_Fptr, "%s  ", mp3.year);
       if(gen)
         fprintf(Out_Fptr, "%s  ", genres[mp3.genre]);
       if(len)
         fprintf(Out_Fptr, "%d:%02d  ", length/60, length%60);
       fprintf(Out_Fptr, "\n");
     }
}

// Procedure out_html
//   input: file  - filename
//   output: none
//   returns: none
//   displays or writes filename, title, interpret, comment, album, year and
//   genre on screen or to an html file
void out_html(char *file)
{
     if(std_out)
     {
       out_text(file);
     }
     else
     {
       kill_too_many_spaces(mp3.title);
       kill_too_many_spaces(mp3.interpret);
       kill_too_many_spaces(mp3.album);
       kill_too_many_spaces(mp3.comment);
       fprintf(Out_Fptr, "      <tr>\n");
       if(fil)
       {
         fprintf(Out_Fptr, "        <td>  ");
         if(cl)
         {
           if(lf)
           {
             fprintf(Out_Fptr, "          <A HREF=\"%s%s\">\n", cur_path, longfile.name);
             fprintf(Out_Fptr, "            %s\n", longfile.name);
           }
           else
           {
             fprintf(Out_Fptr, "          <A HREF=\"%s%s\">\n", cur_path, file);
             fprintf(Out_Fptr, "            %14s\n", file);
           }
           fprintf(Out_Fptr, "          </A> </td>\n");
         }
         else
           if(lf)
             fprintf(Out_Fptr, "          %14s  </td>\n", longfile.name);
           else
             fprintf(Out_Fptr, "          %14s  </td>\n", file);
       }
       if(tit)
       {
         fprintf(Out_Fptr, "        <td>  ");
         fprintf(Out_Fptr, "          %s  </td>\n", mp3.title);
       }
       if(inr)
       {
         fprintf(Out_Fptr, "        <td>  ");
         fprintf(Out_Fptr, "          %s  </td>\n", mp3.interpret);
       }
       if(com)
       {
         fprintf(Out_Fptr, "        <td>  ");
         fprintf(Out_Fptr, "          [%s]  </td>\n", mp3.comment);
       }
       if(alb)
       {
         fprintf(Out_Fptr, "        <td>  ");
         fprintf(Out_Fptr, "          %s  </td>\n", mp3.album);
       }
       if(yea)
       {
         fprintf(Out_Fptr, "        <td>  ");
         fprintf(Out_Fptr, "          %s  </td>\n", mp3.year);
       }
       if(gen)
       {
         fprintf(Out_Fptr, "        <td>  ");
         fprintf(Out_Fptr, "          %s  </td>\n", genres[mp3.genre]);
       }
       if(len)
       {
         fprintf(Out_Fptr, "        <td>  ");
         fprintf(Out_Fptr, "          %d:%02d  </td>\n",
                 length/60, length%60);
       }
       fprintf(Out_Fptr, "      </tr>\n");
     }
}

// Procedure out_m3u
//   input: file  - filename
//   output: none
//   returns: none
//   creates Winamp Playlist
void out_m3u(char *file)
{
     if(std_out)
     {
       out_text(file);
     }
     else
     {
       if(lf)
         fprintf(Out_Fptr, "%s%s\n", cur_path, longfile.name);
       else
         fprintf(Out_Fptr, "%s%s\n", cur_path, file);
     }
}

// Function layer3_info
//   input: buffer  - 1024 byte buffer
//   output: none
//   returns: 1  - no correct layer 3 info
//            0  - no error
//   reads the layer3-info of a mp3 file
int  layer3_info(char buffer[1024])
{
     int i;
     unsigned int temp;

     for(i=0; i<1023; i++)
     {
       temp=( (buffer[i]<<4)&(0xFF0) ) | ( (buffer[i+1]>>4)&(0xE) );
       if((temp==0xFF0)||(temp==0xFFE))
       {
         break;
       }
     }
     if((temp!=0xFF0)&&(temp!=0xFFE))
       return 1;

     temp=((buffer[i+1]>>3)&(0x3));
     if(temp==3)
       layer3.version=0;
     if(temp==2)
       layer3.version=1;
     if(temp==0)
       layer3.version=2;
     layer3.layer=4-((buffer[i+1]>>1)&(0x3));
     layer3.error_protection=!((buffer[i+1])&(0x1));
     layer3.bitrate_index=((buffer[i+2]>>4)&(0xF));
     layer3.sampling_frequency=((buffer[i+2]>>2)&(0x3));
     layer3.padding=((buffer[i+2]>>1)&(0x1));
     layer3.extension=((buffer[i+2])&(0x1));
     layer3.mode=((buffer[i+3]>>6)&(0x3));
     layer3.mode_ext=((buffer[i+3]>>4)&(0x3));
     layer3.copyright=((buffer[i+3]>>3)&(0x1));
     layer3.original=((buffer[i+3]>>2)&(0x1));
     layer3.emphasis=((buffer[i+3])&(0x3));
     layer3.stereo=(layer3.mode==3) ? 0 : 1;  // 1 -> stereo,   0 -> mono
     if(bitrate()!=0)
       length=(file_length)/(bitrate()*125);
     all_length+=length;
     return 0;
}

// Function read_tag
//   input: file  - filename
//   output: none
//   returns: 1  - error opening file
//            0  - no error
//   reads the id3-tag of a mp3 file
int  read_tag(char *file)
{
     FILE *Fptr;
     char buffer[129];
     char layer3buffer[1025];
     int i,j;

     if((Fptr=fopen(file, "rb"))==0)
       return 1;

     file_length=filelength(fileno(Fptr));

     fseek(Fptr, -128, SEEK_END);

     memset(buffer, 0, 128);

     fread(buffer, 1, 128, Fptr);

     if(cur_path[strlen(cur_path)-1]!='\\')
       strcat(cur_path, "\\");

     j=0;
     for(i=0; i<3; i++)
     {
       mp3.tag[i]=buffer[j];
       j++;
     }
     mp3.tag[i]=0;
     for(i=0; i<30; i++)
     {
       mp3.title[i]=buffer[j];
       j++;
     }
     mp3.title[i]=0;
     for(i=0; i<30; i++)
     {
       mp3.interpret[i]=buffer[j];
       j++;
     }
     mp3.interpret[i]=0;
     for(i=0; i<30; i++)
     {
       mp3.album[i]=buffer[j];
       j++;
     }
     mp3.album[i]=0;
     for(i=0; i<4; i++)
     {
       mp3.year[i]=buffer[j];
       j++;
     }
     mp3.year[i]=0;
     for(i=0; i<30; i++)
     {
       mp3.comment[i]=buffer[j];
       j++;
     }
     mp3.comment[i]=0;
     mp3.genre=buffer[j];
     j++;

     fseek(Fptr, 0, SEEK_SET);
     memset(layer3buffer, 0, 1024);
     fread(layer3buffer, 1, 1024, Fptr);
     if(layer3_info(layer3buffer)!=0)
       printf("%s: no valid mp3 header\n", file);

     if(strcmpi(mp3.tag, "TAG")!=0)
     {
       strcpy(mp3.title, "Unknown Title");
       strcpy(mp3.interpret, "Unknown Interpret");
       strcpy(mp3.album, "\0");
       strcpy(mp3.comment, "\0");
       strcpy(mp3.year, "----");
       mp3.genre=255;
     }
     if(m3u!=1)
     {
       if(htm)
         out_html(file);
       else
         out_text(file);
     }
     else
       out_m3u(file);

     fclose(Fptr);

     return 0;
}

// Function read_dir
//   input: path  - start directory for scanning
//          pat  - search patter (*.MP3 or *.*)
//   output: none
//   returns: 0xFF  - keyboard hit
//            0  - no error
//   starts searching for files in path with pattern pat. if rec==1
//   (recursive listing) the function change the directory call itself
//   and continues searching. uses procedure read_tag.
//   lists also system, hidden, archive and read-only files.
int  read_dir(char *path, char *pat)
{
     struct find_t ffblk;
     char tmp[MAXPATH];
     int done, hnd;

     if(rt==0xFF)
       return 0xFF;
     chdir(path);
     strcpy(cur_path, path);

     if(_dos_findfirst(pat, 0xFF, &ffblk)==0)
     {                                           // If there are some files
       if((htm)&&(!std_out)&&(m3u!=1))
       {
         fprintf(Out_Fptr, "  <B>  %s  </B> <BR> <BR>\n", path);
         fprintf(Out_Fptr, "    <TABLE WIDTH=100%>\n");
       }
       if((!htm)&&(!std_out)&&(m3u!=1))
         fprintf(Out_Fptr, "%s\n", path);

     // Search for files in directory
     done=0;
     if(lf)  // If long file names used
       hnd=long_findfirst(pat, 0xFF);
     else
       done=_dos_findfirst(pat, 0xFF, &ffblk);
     while (!done)
     {
       files++;  // number of files found
       if(lf)
       {  // If long file names used
         if((strcmpi(longfile.name, ".")!=0)&&
            (strcmpi(longfile.name, "..")!=0)&&
            ((longfile.attributes&FA_DIREC)!=FA_DIREC)&&
            ((longfile.attributes&FA_LABEL)!=FA_LABEL))
         {
           if(longfile.shortname[0]==0)
             strcpy(longfile.shortname, longfile.name);
           read_tag(longfile.shortname);
         }
         done=long_findnext(hnd);
       }
       else
       {
         if((strcmpi(ffblk.name, ".")!=0)&&
            (strcmpi(ffblk.name, "..")!=0)&&
            ((ffblk.attrib&FA_DIREC)!=FA_DIREC)&&
            ((ffblk.attrib&FA_LABEL)!=FA_LABEL))
           read_tag(ffblk.name);
         done=_dos_findnext(&ffblk);
       }  // end else if long file names used
       if(kbhit())
       {
         getch();
         rt=0xFF;
       }
     }

     if((htm)&&(!std_out)&&(m3u!=1))
     {
       fprintf(Out_Fptr, "    </TABLE>\n");
       fprintf(Out_Fptr, "  <P> <BR>\n");
     }
     if((!htm)&&(!std_out)&&(m3u!=1))
       fprintf(Out_Fptr, "\n\n");

     }                                           // end - if there are some f

     if(!rec)
       return rt;

     // Search for next directory
     done=_dos_findfirst("*.*", 0xFF, &ffblk);
     while (!done)
     {
       if((strcmpi(ffblk.name, ".")!=0)&&
          (strcmpi(ffblk.name, "..")!=0))
       {
         if((ffblk.attrib&FA_DIREC)==FA_DIREC)
         {
           strcpy(tmp, path);
           if(tmp[strlen(tmp)-1]!='\\')
             strcat(tmp, "\\");
           strcat(tmp, ffblk.name);
           printf("-> [%s]\n", tmp);
           read_dir(tmp, pat);
           chdir("..");
         }
       }
       done=_dos_findnext(&ffblk);
       if(kbhit())
       {
         getch();
         rt=0xFF;
       }
     }

     return rt;
}

// Function make_only_dir
//   input: path  - path (with drive and pattern)
//   output: retpath  - path without pattern
//           retpatt  - pattern extracted from path
//   returns: retpath
char *make_only_dir(char *path, char *retpath, char *retpatt)
{
     char drive[MAXDRIVE];
     char dir[MAXDIR];
     char file[MAXFILE];
     char ext[MAXEXT];

     fnsplit(path, drive, dir, file, ext);
     fnmerge(retpath, drive, dir, 0, 0);
     strcpy(retpatt, file);
     strcat(retpatt, ext);

     return retpath;
}


// exit function for exit() and return;
void exit_function(void)
{
     setvect(0x24, old24h_handler);  // sets old hardware error handler
}


char *prog_title="MP3TAG2.CPP, V2.21 (C) 9.8.1999 by Leo Eibler";
char *contact=
"  E-Mail:    <eibler_leo@gmx.at>  or  <eibler_leo@hotmail.com>\n"
"  ICQ:       28099355\n"
"  Homepage:  http://www.geocities.com/SiliconValley/Bridge/3495\n";
char *progname="MP3TAG2.CPP";


// Function main
//   input: argc  - number of arguments
//          argv  - argument list
//   returns: 1  - no arguments given
//            2  - can't open outputfile
//            3  - user break
//            4  - error drive set
//            0  - no error
//   main function
int  main(int argc, char *argv[])
{
     char beg_wd[MAXPATH], cur_wd[MAXPATH];
     char dir[MAXPATH];
     char patt[MAXPATH];
     char defaultpattern[MAXPATH];
     int i;

     strcpy(outfile, "MP3LIST.HTM");
     strcpy(defaultpattern, "*.MP3");
     all_length=0;
     files=0;

     printf("%s\n", prog_title);

     old24h_handler=getvect(0x24);  // interrupt routine for hardware
     setvect(0x24, new24h_handler); // error (int 0x24)
     atexit(exit_function);

     argc--;
     if(argc<1)
     {
       printf("%s: no arguments given\n", progname);
       printf("Syntax: %s Directory [Options]\n", strupr(argv[0]));
       printf("Options:\n");
       printf("         -f=file.ext   output to file\n");
       printf("       * -h            create html file (-html)\n");
       printf("         -t            create text file (-text)\n");
       printf("         -m3u          creates Winamp Playlist (-playlist)\n");
       printf("         -(not)all     searches all drives for given pattern\n");
       printf("       * -(no)lf       long filenames (-(no)longfilenames)\n");
       printf("       * -(no)l        create link to file, if html (-(no)link)\n");
       printf("       * -(no)r        recursive (-(no)recursive)\n");
       printf("       * -(no)fil      display file (-(no)file)\n");
       printf("       * -(no)tit      display title (-(no)title)\n");
       printf("       * -(no)int      display interpret (-(no)interpret)\n");
       printf("         -(no)alb      display album (-(no)album)\n");
       printf("         -(no)com      display comment (-(no)comment)\n");
       printf("         -(no)gen      display genre (-(no)genre)\n");
       printf("         -(no)yea      display year (-(no)year)\n");
       printf("       * -(no)len      display length of song (-(no)length)\n");
       printf("         -def          default settings * (-default)\n");
       printf("Hit any key to continue...\r");
       getch();
       printf("                          \n");
       printf("Example1: %s C:\\*.MP3 -f=OUT.HTM -com\n", strupr(argv[0]));
       printf("   searches in drive C: for mp3 files and creates the file OUT.HTM\n");
       printf("   in current directory. Also lists comments\n");
       printf("Example2: %s *.MP3 -f=LIST.M3U -m3u -all\n", strupr(argv[0]));
       printf("   searches for mp3 files in all drives and creates the file LIST.M3U\n");
       printf("   (*.M3U.....Winamp Playlist) in current directory\n");
       printf("You can contact me:\n");
       printf("%s", contact);
       exit(1);  // no arguments
     }

     printf("\n");

     if(argc>1)
     {
       for(i=2; i<=argc; i++)
       {
         if((argv[i][0]=='-')||(argv[i][0]=='/'))
           argv[i][0]='-';
         if((argv[i][2]=='=')||(argv[i][2]==':'))
           argv[i][2]='=';

         if((argv[i][1]=='f')&&(argv[i][2]=='='))
         {
           sscanf(argv[i], "-f=%s", outfile);
           std_out=0;
         }
         if((!strcmpi(argv[i], "-h"))||(!strcmpi(argv[i], "-html")))
           htm=1;
         if((!strcmpi(argv[i], "-t"))||(!strcmpi(argv[i], "-text")))
           htm=0;
         if((!strcmpi(argv[i], "-m3u"))||(!strcmpi(argv[i], "-playlist")))
           m3u=1;
         if((!strcmpi(argv[i], "-nom3u"))||(!strcmpi(argv[i], "-noplaylist")))
           m3u=0;
         if((!strcmpi(argv[i], "-lf"))||(!strcmpi(argv[i], "-longfilenames")))
           lf=1;
         if((!strcmpi(argv[i], "-nolf"))||(!strcmpi(argv[i], "-nolongfilenames")))
           lf=0;
         if((!strcmpi(argv[i], "-l"))||(!strcmpi(argv[i], "-link")))
           cl=1;
         if((!strcmpi(argv[i], "-nol"))||(!strcmpi(argv[i], "-nolink")))
           cl=0;
         if((!strcmpi(argv[i], "-r"))||(!strcmpi(argv[i], "-recursive")))
           rec=1;
         if((!strcmpi(argv[i], "-nor"))||(!strcmpi(argv[i], "-norecursive")))
           rec=0;
         if((!strcmpi(argv[i], "-fil"))||(!strcmpi(argv[i], "-file")))
           fil=1;
         if((!strcmpi(argv[i], "-nofil"))||(!strcmpi(argv[i], "-nofile")))
           fil=0;
         if((!strcmpi(argv[i], "-tit"))||(!strcmpi(argv[i], "-title")))
           tit=1;
         if((!strcmpi(argv[i], "-notit"))||(!strcmpi(argv[i], "-notitle")))
           tit=0;
         if((!strcmpi(argv[i], "-int"))||(!strcmpi(argv[i], "-interpret")))
           inr=1;
         if((!strcmpi(argv[i], "-noint"))||(!strcmpi(argv[i], "-nointerpret")))
           inr=0;
         if((!strcmpi(argv[i], "-alb"))||(!strcmpi(argv[i], "-album")))
           alb=1;
         if((!strcmpi(argv[i], "-noalb"))||(!strcmpi(argv[i], "-noalbum")))
           alb=0;
         if((!strcmpi(argv[i], "-com"))||(!strcmpi(argv[i], "-comment")))
           com=1;
         if((!strcmpi(argv[i], "-nocom"))||(!strcmpi(argv[i], "-nocomment")))
           com=0;
         if((!strcmpi(argv[i], "-yea"))||(!strcmpi(argv[i], "-year")))
           yea=1;
         if((!strcmpi(argv[i], "-noyea"))||(!strcmpi(argv[i], "-noyear")))
           yea=0;
         if((!strcmpi(argv[i], "-gen"))||(!strcmpi(argv[i], "-genre")))
           gen=1;
         if((!strcmpi(argv[i], "-nogen"))||(!strcmpi(argv[i], "-nogenre")))
           gen=0;
         if((!strcmpi(argv[i], "-len"))||(!strcmpi(argv[i], "-length")))
           len=1;
         if((!strcmpi(argv[i], "-nolen"))||(!strcmpi(argv[i], "-nolength")))
           len=0;
         if((!strcmpi(argv[i], "-all"))||(!strcmpi(argv[i], "-alldrives")))
           all=1;
         if((!strcmpi(argv[i], "-notall"))||(!strcmpi(argv[i], "-notalldrives")))
           all=0;
         if((!strcmpi(argv[i], "-def"))||(!strcmpi(argv[i], "-default")))
         {
           fil=1;
           inr=1;
           tit=1;
           com=0;
           alb=0;
           yea=0;
           gen=0;
           htm=1;
           rec=1;
           len=1;
           cl=1;
           std_out=1;
         }
       }
     }
     else
     {
       fil=1;
       inr=1;
       tit=1;
       com=0;
       alb=0;
       yea=0;
       gen=0;
       htm=1;
       rec=1;
       len=1;
       cl=1;
       std_out=1;
     }

     if(lf)
     {
       if(check_for_7100()==0)
       {
         printf("%s: No long filenames supported\n", progname);
         lf=0;
       }
     }

     if(!std_out)
     {
       if((Out_Fptr=fopen(outfile, "a+t"))==0)
       {
         printf("%s: Error while opening %s\n", progname, outfile);
         exit(2);  // error opening output file
       }
     }

     getcwd(beg_wd, MAXPATH);

     if(!all)
     {
     strcpy(dir, strupr(argv[1]));

     if(dir[1]==':')
     {
       i=_chdrive(dir[0]-'A'+1);
       if(i!=0)
       {
         printf("%s: Can't set drive %c\n", progname, dir[0]);
         exit(4);  // error drive set
       }
     }
     make_only_dir(dir, dir, patt);
     if(dir[0]==0)
       make_only_dir(beg_wd, dir, 0);
     if(patt[0]==0)
       strcpy(patt, defaultpattern);

     read_dir(dir, patt);
     }
     else
     {
       for(i='C'; i<='Z'; i++)
       {
         printf("[DRIVE %c:]\n", i);
         if(_getdcwd(i-'A'+1, cur_wd, MAXPATH)==0)
         {
           printf("%s: Can't get current workdirectory of drive %c\n",
                  progname, i);
           break;
         }
         make_only_dir(strupr(argv[1]), dir, patt);
         if(patt[0]==0)
           strcpy(patt, defaultpattern);
         sprintf(dir, "%c:\\%s", i, patt);
         make_only_dir(dir, dir, patt);

         if(_chdrive(i-'A'+1)!=0)
         {
             printf("%s: Can't set drive %c\n", progname, i);
             continue;
         }

         read_dir(dir, patt);

         _chdrive(i-'A'+1);
         chdir(cur_wd);
       }
     }

     _chdrive(beg_wd[0]-'A'+1);
     chdir(beg_wd);

     if((!std_out)&&(m3u!=1))
     {
       if(htm)
       {
         fprintf(Out_Fptr, "<BR> <B> %lu Files, %lu:%02lu.%02lu </B>\n", files,
                 all_length/3600, (all_length/60)%60, all_length%60);
         fprintf(Out_Fptr, "<BR><BR> <FONT SIZE=2>\n");
         fprintf(Out_Fptr, "%s <BR>\n", prog_title);
         fprintf(Out_Fptr, "Homepage: <A HREF=\"http://www.geocities.com/SiliconValley/Bridge/3495\">\n");
         fprintf(Out_Fptr, "            http://www.geocities.com/SiliconValley/Bridge/3495\n");
         fprintf(Out_Fptr, "          </A> <BR>\n");
         fprintf(Out_Fptr, "E-Mail: <A HREF=\"mailto: eibler_leo@gmx.at\">\n");
         fprintf(Out_Fptr, "          eibler_leo@gmx.at\n");
         fprintf(Out_Fptr, "        </A>\n");
         fprintf(Out_Fptr, "or: <A HREF=\"mailto: eibler_leo@hotmail.com\">\n");
         fprintf(Out_Fptr, "          eibler_leo@hotmail.com\n");
         fprintf(Out_Fptr, "        </A>\n");
         fprintf(Out_Fptr, "</BR></BR> </FONT SIZE=2>\n");
       }
       else
       {
         fprintf(Out_Fptr, "%lu Files, %lu:%02lu.%02lu\n", files,
                 all_length/3600, (all_length/60)%60, all_length%60);
         fprintf(Out_Fptr, "%s\n", prog_title);
         fprintf(Out_Fptr, "%s\n", contact);
       }
     }

     if(!std_out)
       fclose(Out_Fptr);

     printf("\n");

     printf("You can contact me:\n");
     printf("%s", contact);

     if(rt==0xFF)
     {
       printf("%s: Interrupted by user\n", progname);
       exit(3);  // user break
     }

     return 0;  // no error
}

