/****************************************************************************/
/* MP3TAG2.H  : Version 2.00, created  5.8.1999, by Leo Eibler (eibler_leo@ */
/* MP3TAG2.H  : Include File for MP3TAG2.CPP                         gmx.at)*/
/****************************************************************************/
/* Version History:                                                         */
/*   5. 8.1999     V2.00 (creating)                                         */
/*   8. 8.1999     Last Update                                              */
/*--------------------------------------------------------------------------*/
/*   5. 8.1999     V2.00: MP3 Tag struct, genres, some variables            */
/*   6. 8.1999       LAYER3 struct, Header Info variables                   */
/*   7. 8.1999       global variable for current path                       */
/*   8. 8.1999       length and number of all files                         */
/****************************************************************************/

/*--------------------------------------------------------------------------*/
/*!                                                                        !*/
/*! Thank you Peter D. Kovacs !! Your TAG_PM.HTML module was very usefull  !*/
/*! for me (especially the MPEG Layer III info and the genre information)  !*/
/*!                                                                        !*/
/*--------------------------------------------------------------------------*/

struct MP3
{
  char tag[4];
  char title[31];
  char interpret[31];
  char album[31];
  char year[5];
  char comment[31];
  unsigned char genre;
};

struct LAYER3
{
  unsigned char version;
  unsigned char layer;
  unsigned char error_protection;
  unsigned int bitrate_index;
  unsigned int sampling_frequency;
  unsigned int padding;
  unsigned int extension;
  unsigned char mode;
  unsigned char mode_ext;
  unsigned char copyright;
  unsigned char original;
  unsigned char emphasis;
  unsigned char stereo;
};

unsigned long all_length;  // length of all files in seconds
unsigned long files;  // number of found files

unsigned long file_length;
unsigned int length;
char cur_path[MAXPATH];

char *genres[]=
{
"Blues",
"Classic Rock",
"Country",
"Dance",
"Disco",
"Funk",
"Grunge",
"Hip-Hop",
"Jazz",
"Metal",
"New Age",
"Oldies",
"Other",
"Pop",
"R&B",
"Rap",
"Reggae",
"Rock",
"Techno",
"Industrial",
"Alternative",
"Ska",
"Death Metal",
"Pranks",
"Soundtrack",
"Euro-Techno",
"Ambient",
"Trip-Hop",
"Vocal",
"Jazz+Funk",
"Fusion",
"Trance",
"Classical",
"Instrumental",
"Acid",
"House",
"Game",
"Sound Clip",
"Gospel",
"Noise",
"Alternative Rock",
"Bass",
"Soul",
"Punk",
"Space",
"Meditative",
"Instrumental Pop",
"Instrumental Rock",
"Ethnic",
"Gothic",
"Darkwave",
"Techno-Industrial",
"Electronic",
"Pop-Folk",
"Eurodance",
"Dream",
"Southern Rock",
"Comedy",
"Cult",
"Gangsta",
"Top 40",
"Christian Rap",
"Pop/Funk",
"Jungle",
"Native American",
"Cabaret",
"New Wave",
"Psychadelic",
"Rave",
"Showtunes",
"Trailer",
"Lo-Fi",
"Tribal",
"Acid Punk",
"Acid Jazz",
"Polka",
"Retro",
"Musical",
"Rock & Roll",
"Hard Rock",
"Folk",
"Folk/Rock",
"National Folk",
"Swing",
"Bebop",
"Latin",
"Revival",
"Celtic",
"Bluegrass",
"Avantgarde",
"Gothic Rock",
"Progressive Rock",
"Psychedelic Rock",
"Symphonic Rock",
"Slow Rock",
"Big Band",
"Chorus",
"Easy Listening",
"Acoustic",
"Humour",
"Speech",
"Chanson",
"Opera",
"Chamber Music",
"Sonata",
"Symphony",
"Booty Bass",
"Primus",
"Porn Groove",
"Satire",
"Slow Jam",
"Club",
"Tango",
"Samba",
"Folklore",  // 114
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  // 128
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
"Unknown",  // 255
0,  // 256
0
};

unsigned int my_bitrates[3][3][15]=
{
	     {
	      {0, 32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448},
	      {0, 32, 48, 56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320, 384},
	      {0, 32, 40, 48,  56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320}
	     },
	     {
	      {0, 32, 48, 56,  64,  80,  96, 112, 128, 144, 160, 176, 192, 224, 256},
	      {0, 8,  16, 24,  32,  40,  48,  56,  64,  80,  96, 112, 128, 144, 160},
	      {0, 8,  16, 24,  32,  40,  48,  56,  64,  80,  96, 112, 128, 144, 160}
	     },
	     {
	      {0, 32, 48, 56,  64,  80,  96, 112, 128, 144, 160, 176, 192, 224, 256},
	      {0, 8,  16, 24,  32,  40,  48,  56,  64,  80,  96, 112, 128, 144, 160},
	      {0, 8,  16, 24,  32,  40,  48,  56,  64,  80,  96, 112, 128, 144, 160}
	     }
};

unsigned int my_s_freq[3][4]=
{
	    { 44100, 48000, 32000, 0 },
	    { 22050, 24000, 16000, 0 },
	    { 11025,  8000,  8000, 0 }
};

char *my_mode_names[]=
{ "stereo", "joint-stereo", "dual-ch", "single-ch", "multi-ch", 0 };

char *my_layer_names[]=
{ "I", "II", "III", 0 };

char *my_version_names[]=
{ "MPEG-1", "MPEG-2 LSF", "MPEG-2.5", 0 };

float my_version_nums[3]=
{ 1, 2, 2.5 };




